<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/ADSL/include/ADSL/DirectiveProcessor.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_edb1b7e8f1a5d5a1b864206edd6d398d.html">ADSL</a></li><li class="navelem"><a class="el" href="dir_0ad8890ca26b658b7f4a1511f46d3706.html">include</a></li><li class="navelem"><a class="el" href="dir_02d2e4cabccc4f164a834c9d2dadd160.html">ADSL</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">DirectiveProcessor.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_directive_processor_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright 2017-2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;).</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * You may not use this file except in compliance with the License.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * A copy of the License is located at</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     http://aws.amazon.com/apache2.0/</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * or in the &quot;license&quot; file accompanying this file. This file is distributed</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * express or implied. See the License for the specific language governing</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * permissions and limitations under the License.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#ifndef ALEXA_CLIENT_SDK_ADSL_INCLUDE_ADSL_DIRECTIVEPROCESSOR_H_</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#define ALEXA_CLIENT_SDK_ADSL_INCLUDE_ADSL_DIRECTIVEPROCESSOR_H_</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;array&gt;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;condition_variable&gt;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;deque&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;functional&gt;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &lt;mutex&gt;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &lt;set&gt;</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &lt;thread&gt;</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#include &lt;unordered_map&gt;</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_a_v_s_directive_8h.html">AVSCommon/AVS/AVSDirective.h</a>&gt;</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_directive_handler_interface_8h.html">AVSCommon/SDKInterfaces/DirectiveHandlerInterface.h</a>&gt;</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_directive_router_8h.html">ADSL/DirectiveRouter.h</a>&quot;</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a> {</div><div class="line"><a name="l00036"></a><span class="lineno"><a class="line" href="namespacealexa_client_s_d_k_1_1adsl.html">   36</a></span>&#160;<span class="keyword">namespace </span>adsl {</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00063"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html">   63</a></span>&#160;<span class="keyword">class </span><a class="code" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html">DirectiveProcessor</a> {</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html#a43c583510353b8020de277ea98277acb">DirectiveProcessor</a>(<a class="code" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_router.html">DirectiveRouter</a>* directiveRouter);</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html#a58fe40618370125a058a6ebcd3ad6e76">~DirectiveProcessor</a>();</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html#a79f12de0f2919c6cd38cb0452c5b8523">setDialogRequestId</a>(<span class="keyword">const</span> std::string&amp; dialogRequestId);</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html#a90f8c546cb39a806374911fa73759013">onDirective</a>(std::shared_ptr&lt;avsCommon::avs::AVSDirective&gt; directive);</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html#ae2faaf7acc90e86198035959717b24d2">shutdown</a>();</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html#abd74610d3b03928586673816b9b983bf">disable</a>();</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html#a099e3796f20c3081d9479d25b2c87626">enable</a>();</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    <span class="keyword">using</span> ProcessorHandle = <span class="keywordtype">unsigned</span> int;</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    <span class="keyword">using</span> DirectiveAndPolicy = std::pair&lt;std::shared_ptr&lt;avsCommon::avs::AVSDirective&gt;, <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_blocking_policy.html">avsCommon::avs::BlockingPolicy</a>&gt;;</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    <span class="keyword">class </span>DirectiveHandlerResult : <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_result_interface.html">avsCommon::sdkInterfaces::DirectiveHandlerResultInterface</a> {</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;        DirectiveHandlerResult(</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;            ProcessorHandle processorHandle,</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;            std::shared_ptr&lt;avsCommon::avs::AVSDirective&gt; directive);</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;        <span class="keywordtype">void</span> setCompleted() <span class="keyword">override</span>;</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;        <span class="keywordtype">void</span> setFailed(<span class="keyword">const</span> std::string&amp; description) <span class="keyword">override</span>;</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        ProcessorHandle m_processorHandle;</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;        std::shared_ptr&lt;avsCommon::avs::AVSDirective&gt; m_directive;</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;    };</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;    <span class="keywordtype">void</span> onHandlingCompleted(std::shared_ptr&lt;avsCommon::avs::AVSDirective&gt; directive);</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;    <span class="keywordtype">void</span> onHandlingFailed(std::shared_ptr&lt;avsCommon::avs::AVSDirective&gt; directive, <span class="keyword">const</span> std::string&amp; description);</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;    <span class="keywordtype">void</span> removeDirectiveLocked(std::shared_ptr&lt;avsCommon::avs::AVSDirective&gt; directive);</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;    <span class="keywordtype">void</span> processingLoop();</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;    <span class="keywordtype">bool</span> processCancelingQueueLocked(std::unique_lock&lt;std::mutex&gt;&amp; lock);</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;    <span class="keywordtype">bool</span> handleQueuedDirectivesLocked(std::unique_lock&lt;std::mutex&gt;&amp; lock);</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;    <span class="keywordtype">void</span> setDialogRequestIdLocked(<span class="keyword">const</span> std::string&amp; dialogRequestId);</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;    <span class="keywordtype">void</span> scrubDialogRequestIdLocked(<span class="keyword">const</span> std::string&amp; dialogRequestId);</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;    <span class="keywordtype">void</span> queueAllDirectivesForCancellationLocked();</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;    <span class="keywordtype">void</span> setDirectiveBeingHandledLocked(</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;        <span class="keyword">const</span> std::shared_ptr&lt;avsCommon::avs::AVSDirective&gt;&amp; directive,</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;        <span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_blocking_policy.html">avsCommon::avs::BlockingPolicy</a> policy);</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;    <span class="keywordtype">void</span> clearDirectiveBeingHandledLocked(<span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_blocking_policy.html">avsCommon::avs::BlockingPolicy</a> policy);</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;    std::set&lt;std::shared_ptr&lt;avsCommon::avs::AVSDirective&gt;&gt; clearDirectiveBeingHandledLocked(</div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;        std::function&lt;<span class="keywordtype">bool</span>(<span class="keyword">const</span> std::shared_ptr&lt;avsCommon::avs::AVSDirective&gt;&amp;)&gt; shouldClear);</div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;    std::deque&lt;DirectiveAndPolicy&gt;::iterator getNextUnblockedDirectiveLocked();</div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;    <span class="keywordtype">int</span> m_handle;</div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;</div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;    std::mutex m_mutex;</div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;</div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_router.html">DirectiveRouter</a>* m_directiveRouter;</div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;</div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;    <span class="keywordtype">bool</span> m_isShuttingDown;</div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;    <span class="keywordtype">bool</span> m_isEnabled;</div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;</div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;    std::string m_dialogRequestId;</div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;</div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;    std::deque&lt;std::shared_ptr&lt;avsCommon::avs::AVSDirective&gt;&gt; m_cancelingQueue;</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;    std::shared_ptr&lt;avsCommon::avs::AVSDirective&gt; m_directiveBeingPreHandled;</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;</div><div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;    std::deque&lt;DirectiveAndPolicy&gt; m_handlingQueue;</div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;</div><div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;    std::condition_variable m_wakeProcessingLoop;</div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;    std::thread m_processingThread;</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;</div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;    std::mutex m_onDirectiveMutex;</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;</div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;    <span class="keyword">static</span> std::mutex m_handleMapMutex;</div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;    <span class="keyword">static</span> std::unordered_map&lt;ProcessorHandle, DirectiveProcessor*&gt; m_handleMap;</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;</div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;    <span class="keyword">static</span> ProcessorHandle m_nextProcessorHandle;</div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;    std::array&lt;std::shared_ptr&lt;avsCommon::avs::AVSDirective&gt;, <a class="code" href="structalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_blocking_policy_1_1_medium.html#a62a8eb926fee107af24e964130f45299aceea6f76ae0d7aa000af0c1f52814e2f">avsCommon::avs::BlockingPolicy::Medium::COUNT</a>&gt;</div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;        m_directivesBeingHandled;</div><div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;};</div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;</div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;}  <span class="comment">// namespace adsl</span></div><div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;}  <span class="comment">// namespace alexaClientSDK</span></div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;</div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;<span class="preprocessor">#endif  // ALEXA_CLIENT_SDK_ADSL_INCLUDE_ADSL_DIRECTIVEPROCESSOR_H_</span></div><div class="ttc" id="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor_html_a43c583510353b8020de277ea98277acb"><div class="ttname"><a href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html#a43c583510353b8020de277ea98277acb">alexaClientSDK::adsl::DirectiveProcessor::DirectiveProcessor</a></div><div class="ttdeci">DirectiveProcessor(DirectiveRouter *directiveRouter)</div><div class="ttdef"><b>Definition:</b> DirectiveProcessor.cpp:47</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor_html_a58fe40618370125a058a6ebcd3ad6e76"><div class="ttname"><a href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html#a58fe40618370125a058a6ebcd3ad6e76">alexaClientSDK::adsl::DirectiveProcessor::~DirectiveProcessor</a></div><div class="ttdeci">~DirectiveProcessor()</div><div class="ttdef"><b>Definition:</b> DirectiveProcessor.cpp:57</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor_html_ae2faaf7acc90e86198035959717b24d2"><div class="ttname"><a href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html#ae2faaf7acc90e86198035959717b24d2">alexaClientSDK::adsl::DirectiveProcessor::shutdown</a></div><div class="ttdeci">void shutdown()</div><div class="ttdef"><b>Definition:</b> DirectiveProcessor.cpp:132</div></div>
<div class="ttc" id="_directive_handler_interface_8h_html"><div class="ttname"><a href="_directive_handler_interface_8h.html">DirectiveHandlerInterface.h</a></div></div>
<div class="ttc" id="structalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_blocking_policy_1_1_medium_html_a62a8eb926fee107af24e964130f45299aceea6f76ae0d7aa000af0c1f52814e2f"><div class="ttname"><a href="structalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_blocking_policy_1_1_medium.html#a62a8eb926fee107af24e964130f45299aceea6f76ae0d7aa000af0c1f52814e2f">alexaClientSDK::avsCommon::avs::BlockingPolicy::Medium::COUNT</a></div><div class="ttdoc">Number of mediums. This MUST be the last enum member. </div><div class="ttdef"><b>Definition:</b> BlockingPolicy.h:42</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1adsl_1_1_directive_router_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1adsl_1_1_directive_router.html">alexaClientSDK::adsl::DirectiveRouter</a></div><div class="ttdef"><b>Definition:</b> DirectiveRouter.h:34</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html">alexaClientSDK::adsl::DirectiveProcessor</a></div><div class="ttdef"><b>Definition:</b> DirectiveProcessor.h:63</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_result_interface_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_result_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::DirectiveHandlerResultInterface</a></div><div class="ttdef"><b>Definition:</b> DirectiveHandlerResultInterface.h:33</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_html"><div class="ttname"><a href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></div><div class="ttdoc">Whether or not curl logs should be emitted. </div><div class="ttdef"><b>Definition:</b> AVSConnectionManager.h:37</div></div>
<div class="ttc" id="_directive_router_8h_html"><div class="ttname"><a href="_directive_router_8h.html">DirectiveRouter.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_blocking_policy_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_blocking_policy.html">alexaClientSDK::avsCommon::avs::BlockingPolicy</a></div><div class="ttdef"><b>Definition:</b> BlockingPolicy.h:29</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor_html_abd74610d3b03928586673816b9b983bf"><div class="ttname"><a href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html#abd74610d3b03928586673816b9b983bf">alexaClientSDK::adsl::DirectiveProcessor::disable</a></div><div class="ttdeci">void disable()</div><div class="ttdef"><b>Definition:</b> DirectiveProcessor.cpp:148</div></div>
<div class="ttc" id="_a_v_s_directive_8h_html"><div class="ttname"><a href="_a_v_s_directive_8h.html">AVSDirective.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor_html_a79f12de0f2919c6cd38cb0452c5b8523"><div class="ttname"><a href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html#a79f12de0f2919c6cd38cb0452c5b8523">alexaClientSDK::adsl::DirectiveProcessor::setDialogRequestId</a></div><div class="ttdeci">void setDialogRequestId(const std::string &amp;dialogRequestId)</div><div class="ttdef"><b>Definition:</b> DirectiveProcessor.cpp:61</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor_html_a099e3796f20c3081d9479d25b2c87626"><div class="ttname"><a href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html#a099e3796f20c3081d9479d25b2c87626">alexaClientSDK::adsl::DirectiveProcessor::enable</a></div><div class="ttdeci">bool enable()</div><div class="ttdef"><b>Definition:</b> DirectiveProcessor.cpp:156</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor_html_a90f8c546cb39a806374911fa73759013"><div class="ttname"><a href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html#a90f8c546cb39a806374911fa73759013">alexaClientSDK::adsl::DirectiveProcessor::onDirective</a></div><div class="ttdeci">bool onDirective(std::shared_ptr&lt; avsCommon::avs::AVSDirective &gt; directive)</div><div class="ttdef"><b>Definition:</b> DirectiveProcessor.cpp:66</div></div>
</div><!-- fragment --></div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
